package com.hfkj.service.card;

import com.hfkj.entity.BsUser;
import com.hfkj.entity.BsUserCard;
import com.hfkj.sysenum.UserCardStatusEnum;
import com.hfkj.sysenum.UserCardTypeEnum;

import java.util.List;
import java.util.Map;

/**
 * @className: BsUserCardService
 * @author: HuRui
 * @date: 2024/5/17
 **/
public interface BsUserCardService {

    /**
     * 编辑数据
     * @param data
     */
    void editData(BsUserCard data);

    /**
     * 查询卡
     * @param cardNo
     * @return
     */
    BsUserCard getCard(String cardNo);
    BsUserCard getCard(Long userId);

    /**
     * @MethodName insertUserCardBatch
     * @Description: 批量插入工会卡
     * @param data
     * @Author: Sum1Dream
     * @Date: 2024/7/25 上午9:58
     */
    void insertUserCardBatch(List<BsUserCard> data);

    /**
     * @MethodName updateUserCardBatch
     * @Description:批量更新工会卡
     * @param data
     * @Author: Sum1Dream
     * @Date: 2024/7/25 上午9:58
     */
    void updateUserCardBatch(List<BsUserCard> data);

    /**
     * 查询卡
     * @param userId
     * @param cardNo
     * @return
     */
    BsUserCard getCard(Long userId,String cardNo);

    /**
     * 查询卡
     * @param userId
     * @return
     */
    List<BsUserCard> getCardList(Long userId, UserCardTypeEnum type);


    List<BsUserCard> getCardList(Map<String , Object> map);

    /**
     * 绑定卡号
     * @param type
     * @param userId
     * @param cardNo
     */
    void bindCard(UserCardTypeEnum type,Long userId,String cardNo) throws Exception;

    /**
     * 解绑
     * @param userId
     * @param cardNo
     */
    void unbindCard(Long userId,String cardNo);

}
